function [w, iter] = mdistrain(x, y, w0, lam,  k, p,  maxiter, tol)
% The main training funnction mdistrain.m
% Written by Zhenqiu Liu UMB
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin < 8,
    tol = 1e-5;
end;
if nargin < 7,
    maxiter =1000;
end
if nargin < 6,
    p =1;
end
if nargin < 5,
    k =3;
end
if nargin < 4;
    lam = 200;
end
n = size(x, 2);
if nargin < 3,
    w0 = ones(n,1);
end

[Z1, Z2] = MatrixInput(x, y, k, p);
[w, iter] = conjgradtrain(w0, @mycgLineSearch, {'c2', 1e-3}, @tlsq, {Z1, Z2, lam},'tol', tol,'maxiter', maxiter, 'verbose',0);


end

