load NBData20;
Y = Y20;
X = X20;
Xn = arcsinVST(X);

J1 = find(Y==1);
J2 = find(Y==2);
J3 = find(Y==3);
J4 = find(Y==4);
J5 = find(Y==5);


Xn1 = Xn(J1,:);
Xn2 = Xn(J2,:);
Xn3 = Xn(J3,:);
Xn4 = Xn(J4,:);
Xn5 = Xn(J5,:);

n = size(Xn1,1);


%for i =1:100,
Xn1 = Xn1(randperm(n), :);
Xn2 = Xn2(randperm(n), :);
Xn3 = Xn3(randperm(n),:);
Xn4 = Xn4(randperm(n),:);
Xn5 = Xn5(randperm(n),:);





x = [Xn1(1:ceil(n/2),:); Xn2(1:ceil(n/2),:); Xn3(1:ceil(n/2),:); Xn4(1:ceil(n/2),:); Xn5(1:ceil(n/2),:) ];
y =[ones(ceil(n/2),1); 2*ones(ceil(n/2),1); 3*ones(ceil(n/2), 1); 4*ones(ceil(n/2), 1); 5*ones(ceil(n/2), 1)];



xt = [ Xn1(ceil(n/2)+1:n, :); Xn2(ceil(n/2)+1:n, :); Xn3(ceil(n/2)+1:n, :); Xn4(ceil(n/2)+1:n, :); Xn5(ceil(n/2)+1:n,:)];
yt = [ones(n-ceil(n/2), 1); 2*ones(n-ceil(n/2), 1); 3*ones(n-ceil(n/2),1); 4*ones(n-ceil(n/2), 1); 5*ones(n-ceil(n/2), 1)];


[m1, nn1] = size(x);
[m2, nn2] = size(xt);

k = 6;
lam = 5;
p= 1;
tol = 1e-6;
maxiter = 1000;
w0 =ones(nn1,1);
[w, iter] = mdistrain(x, y, w0, lam, k, p, maxiter, tol);
 w(w<0.0001) =0
 
%Model test 
[t1,  t2] = mdisttest(x, y, xt, yt, w, k, p, 1)
J = find(w > 0)

%Compare with knn without feature selection.
c = knnclassify(xt, x, y, k);
mc =sum(c ~= yt)/length(yt)

%end
